/*

a simple GA framework

*/

#ifndef EVO
#define EVO

#define TRUE 1
#define FALSE 0

struct SettingsStruct
{
	int allelesPerChromosome;
	int numChromosomes;
	int	numGenerations;
	float mutationProbability;
	float elitismRate;
};

void ReadSettings(SettingsStruct * settings);
void SkipComments(FILE * file);
void FindNewLine(FILE * file);


class Evo
{
public:

	Evo(SettingsStruct * theSettings);
	virtual ~Evo();
	
	void Run();


private:
	
	void InitializeGenePool(int numChromosomes, int numAlleles);
	void PrintChromosome(Chromosome * ch);

	void DoGeneration();
	
	Chromosome * SelectParent();
	Chromosome * SelectBest();
	Chromosome * SelectWorst();
	void Crossover(Chromosome * parentA, Chromosome * parentB, Chromosome * child);
	int MaybeMutateChromosome(Chromosome * ch);
	void MutateChromosome(Chromosome * ch);
	float EvaluateChromosome(Chromosome * ch);
	void Output(int kill);
	
	Chromosome* chromosomes;
	
	SettingsStruct * settings;

};


#endif
	
